#include "screen_objects.h"
#include "screen_resources.h"

//--------------------- User code ---------------------//
  unsigned char low (unsigned int two_byte)  //     
  {return (two_byte&0b0000000011111111);}

  unsigned char high (unsigned int two_byte) //     
  {return ((two_byte&0b1111111100000000)>>8);}

void E2P_write_int(unsigned int addr, unsigned int two_byte) //      addr    Int
{
    unsigned char low_byte;
    unsigned char high_byte;
    low_byte=low(two_byte);
    high_byte=high(two_byte);
    EEPROM_Write (addr++,high_byte);
    EEPROM_Write (addr,low_byte);
}
 unsigned int  E2P_read_int (unsigned int addr)   //      addr  Int
 {
      return (EEPROM_read(addr++)<<8) + EEPROM_read(addr);
 }
unsigned int eex, eey;
// Start time --------------
// Software I2C connections
sbit Soft_I2C_Scl_Output    at PORTD0_bit;
sbit Soft_I2C_Sda_Output    at PORTD1_bit;
sbit Soft_I2C_Scl_Input     at PIND0_bit;
sbit Soft_I2C_Sda_Input     at PIND1_bit;
sbit Soft_I2C_Scl_Direction at DDD0_bit;
sbit Soft_I2C_Sda_Direction at DDD1_bit;
// End Software I2C connections

char sek, seconds, minutes, hours, day, weekday, month, year;    // Global date/time variables
char second[16], minute[16], hour[16], days[16], weekdays[16], chislos[16], mecs[16], chiss[16], dogs[16], hhs[16], mms[16], sss[16];
unsigned int chislo, mec, chis, dog, nedd, vv, hh, mm, ss, abv, c_ear;

void Read_Time() {
  sek = seconds;
  Soft_I2C_Start();               // Issue start signal
  Soft_I2C_Write(0xA0);           // Address PCF8583, see PCF8583 datasheet
  Soft_I2C_Write(2);              // Start from address 2
  Soft_I2C_Start();               // Issue repeated start signal
  Soft_I2C_Write(0xA1);           // Address PCF8583 for reading R/W=1

  seconds = Soft_I2C_Read(1);     // Read seconds byte
  minutes = Soft_I2C_Read(1);     // Read minutes byte
  hours = Soft_I2C_Read(1);       // Read hours byte
  day = Soft_I2C_Read(1);         // Read year/day byte
  month = Soft_I2C_Read(0);       // Read weekday/month byte
  Soft_I2C_Stop();                // Issue stop signal

//-------------------- Formats date and time
  seconds  =  ((seconds & 0xF0) >> 4)*10 + (seconds & 0x0F);  // Transform seconds
  minutes  =  ((minutes & 0xF0) >> 4)*10 + (minutes & 0x0F);  // Transform months
  hours    =  ((hours & 0xF0)  >> 4)*10  + (hours & 0x0F);    // Transform hours
  year     =   (day & 0xC0) >> 6;                             // Transform year
  day      =  ((day & 0x30) >> 4)*10 + (day & 0x0F);          // Transform day
  weekday  =  ((month & 0xE0) >> 5 );                         // Transform weekday  
  month    =  ((month & 0x10)  >> 4)*10 + (month & 0x0F);     // Transform month 

  if (seconds > sek) { print_time();}
}

// Cyrillic font for RTC
char mes[12][35] = { "\xF1\xCE\xD7\xC1\xD2\xD1","\xE6\xC5\xD7\xD2\xC1\xCC\xD1","\xED\xC1\xD2\xD4\xC1","\xE1\xD0\xD2\xC5\xCC\xD1","\xED\xC1\xD1","\xE9\xC0\xCE\xD1","\xE9\xC0\xCC\xD1","\xE1\xD7\xC7\xD5\xD3\xC1","\xF3\xC5\xCE\xD4\xD1\xC2\xD2\xD1","\xEF\xCB\xD4\xD1\xC2\xD2\xD1","\xEE\xCF\xD1\xC2\xD2\xD1","\xE4\xC5\xCB\xC1\xC2\xD2\xD1" }; // months
char ned[7][9] = { "\xF0\xCE","\xF7\xD4","\xF3\xD2","\xFE\xD4","\xF0\xD4","\xF3\xC2","\xF7\xD3" }; //weekdays

void print_time() {
  TFT_16bit_Set_Pen(CL_BLACK_16bit, 15);
  TFT_16bit_Line(30, 225+7, 280, 225+7);
  TFT_16bit_Set_Ext_Font(Lucida_Console_KOI89x14_Bold, CL_WHITE_16bit, FO_HORIZONTAL_16bit);
  IntToStr(seconds, second);
  IntToStr(minutes, minute);
  IntToStr(hours, hour);
  IntToStr(day, days);
  TFT_16bit_Write_Text(hour, 165, 225);
  TFT_16bit_Write_Text(":", 210, 225);
  TFT_16bit_Write_Text(minute, 195, 225);
  TFT_16bit_Write_Text(":", 240, 225);
  TFT_16bit_Write_Text(second, 225, 225);
  TFT_16bit_Write_Text(days, 10, 225);
  TFT_16bit_Write_Text(&mes[month-1], 65, 225);
  TFT_16bit_Write_Text(&ned[weekday], 135, 225);
}

void Write_Time(unsigned char c_hours, unsigned char c_minutes, unsigned char c_seconds, unsigned char c_date, unsigned char c_month, unsigned char c_year, unsigned char c_wday) {

// c_year = c_year;
c_year = (c_year % 4) << 6;
c_wday = (c_wday) << 5;
   Soft_I2C_Start();      // Issue start signal
   Soft_I2C_Write(0xA0);  // Address PCF8583 datasheet
   Soft_I2C_Write(0);     // Start from address 0 (configuration memory location)
   Soft_I2C_Write(0x80);  // Write 0x80 to configuration memory location (pause counter...)
   Soft_I2C_Write(0);     // Write 0 to cents memory location
   Soft_I2C_Write(c_seconds);     // Write 0 to seconds memory location
   Soft_I2C_Write(c_minutes);  // Write 0x30 to minutes memory location
   Soft_I2C_Write(c_hours);  // Write 0x9 to hours memory location
   Soft_I2C_Write(c_date | c_year);  // Write 0x24 to date/year memory location
   Soft_I2C_Write(c_month | c_wday);  // Write 0x08 to weekday/month memory location
   Soft_I2C_Stop();       // Issue stop signal

   Soft_I2C_Start();      // Issue start signal
   Soft_I2C_Write(0xA0);  // Address PCF8583
   Soft_I2C_Write(0);     // Start from address 0
   Soft_I2C_Write(0);     // Write 0 to configuration memory location (enable counting)
   Soft_I2C_Stop();       // Issue stop signal

}

//   end time -----------------------------------


//----------------- End of User code ------------------//

// Event Handlers
void usttime() {
  DrawScreen(&Screen2);
  chis = 0;
  chislo = 0;
  mec = 0;
  dog = 2000;
  nedd = 0;
  vv = 47;
  hh = 0;
  mm = 0;
  ss = 0;
  abv = 0;
}

void odin() {
  if ( chis == 0 ) { chislo = 10; }
  if ( chis == 1 ) { chislo++; }
  if ( chis == 2 ) { mec = 10; }
  if ( chis == 3 ) { mec++;  }
  if ( chis == 4 ) { dog+=10;  }
  if ( chis == 5 ) { dog++;  }
  if ( chis == 6 ) { nedd = 0;  }
  if ( chis == 7 ) { hh=10;  }
  if ( chis == 8 ) { hh++;  }
  if ( chis == 9 ) { mm=10;  }
  if ( chis == 10 ) { mm++;  }
  if ( chis == 11 ) { ss=10;  }
  if ( chis == 12 ) { ss++;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void dva() {
  if ( chis == 0 ) { chislo = 20; }
  if ( chis == 1 ) { chislo+=2; }
  if ( chis == 3 ) { mec+=2;  }
  if ( chis == 4 ) { dog+=20;  }
  if ( chis == 5 ) { dog+=2;  }
  if ( chis == 6 ) { nedd = 1;  }
  if ( chis == 7 ) { hh=20;  }
  if ( chis == 8 ) { hh+=2;  }
  if ( chis == 9 ) { mm=20;  }
  if ( chis == 10 ) { mm+=2;  }
  if ( chis == 11 ) { ss=20;  }
  if ( chis == 12 ) { ss+=2;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void tri() {
  if ( chis == 0 ) { chislo = 30; }
  if ( chis == 1 ) { chislo+=3; }
  if ( chis == 3 ) { mec+=3;  }
  if ( chis == 4 ) { dog+=30;  }
  if ( chis == 5 ) { dog+=3;  }
  if ( chis == 6 ) { nedd = 2;  }
  if ( chis == 8 ) { hh+=3;  }
  if ( chis == 9 ) { mm=30;  }
  if ( chis == 10 ) { mm+=3;  }
  if ( chis == 11 ) { ss=30;  }
  if ( chis == 12 ) { ss+=3;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void chetire() {
  if ( chis == 1 ) { chislo+=4; }
  if ( chis == 3 ) { mec+=4;  }
  if ( chis == 4 ) { dog+=40;  }
  if ( chis == 5 ) { dog+=4;  }
  if ( chis == 6 ) { nedd = 3;  }
  if ( chis == 8 ) { hh+=4;  }
  if ( chis == 9 ) { mm=40;  }
  if ( chis == 10 ) { mm+=4;  }
  if ( chis == 11 ) { ss=40;  }
  if ( chis == 12 ) { ss+=4;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void pyat() {
  if ( chis == 1 ) { chislo+=5; }
  if ( chis == 3 ) { mec+=5;  }
  if ( chis == 4 ) { dog+=50;  }
  if ( chis == 5 ) { dog+=5;  }
  if ( chis == 6 ) { nedd = 4;  }
  if ( chis == 8 ) { hh+=5;  }
  if ( chis == 9 ) { mm=50;  }
  if ( chis == 10 ) { mm+=5;  }
  if ( chis == 11 ) { ss=50;  }
  if ( chis == 12 ) { ss+=5;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void chest() {
  if ( chis == 1 ) { chislo+=6; }
  if ( chis == 3 ) { mec+=6;  }
  if ( chis == 4 ) { dog+=60;  }
  if ( chis == 5 ) { dog+=6;  }
  if ( chis == 6 ) { nedd = 5;  }
  if ( chis == 8 ) { hh+=6;  }
  if ( chis == 10 ) { mm+=6;  }
  if ( chis == 12 ) { ss+=6;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void sem() {
  if ( chis == 1 ) { chislo+=7; }
  if ( chis == 3 ) { mec+=7;  }
  if ( chis == 4 ) { dog+=70;  }
  if ( chis == 5 ) { dog+=7;  }
  if ( chis == 6 ) { nedd = 6;  }
  if ( chis == 8 ) { hh+=7;  }
  if ( chis == 10 ) { mm+=7;  }
  if ( chis == 12 ) { ss+=7;  }
  if ( chis > 12 ) { usttime();  }
  viv ();;
}

void vosem() {
  if ( chis == 1 ) { chislo+=8; }
  if ( chis == 3 ) { mec+=8;  }
  if ( chis == 4 ) { dog+=80;  }
  if ( chis == 5 ) { dog+=8;  }
  if ( chis == 8 ) { hh+=8;  }
  if ( chis == 10 ) { mm+=8;  }
  if ( chis == 12 ) { ss+=8;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void devyat() {
  if ( chis == 1 ) { chislo+=9; }
  if ( chis == 3 ) { mec+=9;  }
  if ( chis == 4 ) { dog+=90;  }
  if ( chis == 5 ) { dog+=9;  }
  if ( chis == 8 ) { hh+=9;  }
  if ( chis == 10 ) { mm+=9;  }
  if ( chis == 12 ) { ss+=9;  }
  if ( chis > 12 ) { usttime();  }
  viv ();
}

void nol() {
  if ( chis > 12 ) { usttime();  }
  viv ();
}

unsigned char hhh, mmh, ssh, chh, meh;

void enter() {
    hhh = Dec2Bcd(hh);
    mmh = Dec2Bcd(mm);
    ssh = Dec2Bcd(ss);
    chh = Dec2Bcd(chislo);
    meh = Dec2Bcd(mec);
    Write_Time(hhh, mmh, ssh, chh, meh, dog, nedd);
   //   Write   13:10:00  16 Oktober 2012 Tuesday
   abv = 1;
   while (abv) {
    Check_TP();
    Read_Time();
    }
}

void zpt() {
 abv = 0;
 usttime();
}

void oratno() {
  abv = 0;
  DrawScreen(&Screen1);
}

void out() {
  DrawScreen(&Screen4);
  pwm2_star();
}

void setting() {
  abv = 0;
  DrawScreen(&Screen1);
  pwm2_star();
  // PWM2_Set_Duty(50);
}

void reset() {
    TFT_16bit_Set_Pen(CL_Silver_16bit, 34);
    TFT_16bit_Line(13, 55, 306, 55);
    Read_Time();
}


void viv() {
  reset();
  TFT_16bit_Set_Ext_Font(Lucida_Console_KOI812x20_Bold, CL_Black_16bit, FO_HORIZONTAL_16bit);
  if ((( mec == 1) || (mec == 3) || (mec == 5) || (mec == 7) || (mec == 8) || (mec == 10) || (mec == 12)) && (chislo > 31))  { chislo = 31; }
  if ((( mec == 4) || (mec == 6) || (mec == 9) || (mec == 11)) && (chislo > 30))  { chislo = 30; }
  if (( mec == 2 ) && ( chislo > 29 )) { chislo = 29;}
  if ( mec > 12 ) { mec = 12;}
  if ( hh > 23 ) { hh = 23;}
  if ( nedd > 7 ) { nedd = 7;}
  c_ear = (dog % 4) << 6;
  if (( mec == 2 ) && ( c_ear != 0 ) && ( chis > 4 ) && ( chislo > 28 )) { chislo = 28;}
  IntToStr(chislo, chislos);
  IntToStr(mec, mecs);
  IntToStr(dog, dogs);
  IntToStr(hh, hhs);
  IntToStr(mm, mms);
  IntToStr(ss, sss);
  TFT_16bit_Write_Text(chislos, 0, vv);
  TFT_16bit_Write_Text(".", 52, vv);
  TFT_16bit_Write_Text(mecs, 35, vv);
  TFT_16bit_Write_Text(".", 86, vv);
  TFT_16bit_Write_Text(dogs, 80, vv);
  TFT_16bit_Write_Text(&ned[nedd], 170, vv);
  TFT_16bit_Write_Text(hhs, 190, vv);
  TFT_16bit_Write_Text(":", 240, vv);
  TFT_16bit_Write_Text(mms, 220, vv);
  TFT_16bit_Write_Text(":", 270, vv);
  TFT_16bit_Write_Text(sss, 250, vv);
  IntToStr(chis, chiss);
  // TFT_16bit_Write_Text(chiss, 240, 47);
  chis++;
  // delay_ms(100);
}

unsigned int duryroma1, duryroma2, duryroma3;
char duryrom1[16],duryrom2[16],duryrom3[16];
unsigned int xxx, yyy;
void lamp() {
  DrawScreen(&Screen3);
  // duryroma3 = 50;
  TFT_16bit_Set_Ext_Font(Lucida_Console_KOI89x14_Bold, CL_Black_16bit, FO_HORIZONTAL_16bit);
  xxx = 123; yyy = 38;
}

void bridg1() {
  TFT_16bit_Set_Pen(CL_WHITE_16bit, 34);
  TFT_16bit_Line(xxx, yyy+64, xxx+50, yyy+64);
  duryroma3 = E2P_read_int(0x00);
  duryroma3=duryroma3-5;
  if (duryroma3 > 254) { duryroma3 = 254; }
  PWM2_Set_Duty(duryroma3);
  E2P_write_int(0x00,duryroma3);
  duryroma3 = E2P_read_int(0x00);
  IntToStr(duryroma3,duryrom3);
  TFT_16bit_Write_Text(duryrom3, xxx, yyy+70);
}

void bridg2() {
  TFT_16bit_Set_Pen(CL_WHITE_16bit, 34);
  TFT_16bit_Line(xxx, yyy+64, xxx+50, yyy+64);
  duryroma3 = E2P_read_int(0x00);
  duryroma3=duryroma3+5;
  if (duryroma3 > 254) { duryroma3 = 254; }
  PWM2_Set_Duty(duryroma3);
  E2P_write_int(0x00,duryroma3);
  duryroma3 = E2P_read_int(0x00);
  IntToStr(duryroma3,duryrom3);
  TFT_16bit_Write_Text(duryrom3, xxx, yyy+70);
}

void wr() {
E2P_write_int(0x00,eex); //      000  
}

void rd() {
 eey = E2P_read_int(0x00);
}


void pwm2_star() {
  rd();
  if (eey > 254) { eey = 250; PWM2_Set_Duty(eey); }
   else { PWM2_Set_Duty(eey); }
}

/////////////////////////
/* Events Code Declarations
void bridg1();
void bridg2();
void chest();
void chetire();
void devyat();
void dva();
void enter();
void lamp();
void nol();
void odin();
void oratno();
void out();
void pyat();
void reset();
void sem();
void setting();
void tri();
void usttime();
void vosem();
void zpt();
void print_time();
void Read_Time();
void viv();
void wr();
void rd();
void pwm2_star();
 */
/////////////////////////