typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const far char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const far char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef const far struct  CLabel {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const far char          *Caption;
  const far char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCLabel;

typedef struct  Image {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const far char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef const far struct  CImage {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const far char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCImage;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Box_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox_Round;

typedef const far struct  CBox_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCBox_Round;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code far *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code far *Labels;
  unsigned int           CLabelsCount;
  TCLabel                 * const code far *CLabels;
  unsigned int           ImagesCount;
  TImage                 * const code far *Images;
  unsigned int           CImagesCount;
  TCImage                 * const code far *CImages;
  unsigned int           BoxesCount;
  TBox                   * const code far *Boxes;
  unsigned int           Boxes_RoundCount;
  TBox_Round             * const code far *Boxes_Round;
  unsigned int           CBoxes_RoundCount;
  TCBox_Round             * const code far *CBoxes_Round;
};

extern   TScreen                Screen1;
extern   TImage               Image1;
extern   TImage               Image2;
extern   TImage               Image5;
extern   TImage                 * const code far Screen1_Images[3];


extern   TScreen                Screen2;
extern   TBox_Round             BoxRound2;
extern   TLabel                 Label1;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TButton               Button11;
extern   TButton               Button12;
extern   TCBox_Round             BoxRound1;
extern   TLabel                 Label2;
extern   TButton                * const code far Screen2_Buttons[12];
extern   TLabel                 * const code far Screen2_Labels[2];
extern   TBox_Round             * const code far Screen2_Boxes_Round[1];
extern   TCBox_Round             * const code far Screen2_CBoxes_Round[1];


extern   TScreen                Screen3;
extern   TButton               Button14;
extern   TButton               Button15;
extern   TBox                   Box1;
extern   TBox                   Box2;
extern   TBox                   Box3;
extern   TBox                   Box4;
extern   TBox_Round             BoxRound3;
extern   TLabel                 Label3;
extern   TButton                * const code far Screen3_Buttons[2];
extern   TLabel                 * const code far Screen3_Labels[1];
extern   TBox                   * const code far Screen3_Boxes[4];
extern   TBox_Round             * const code far Screen3_Boxes_Round[1];


extern   TScreen                Screen4;
extern   TCImage               Image3;
extern   TCLabel          Label4;
extern   TCLabel          Label5;
extern   TImage               Image4;
extern   TCLabel                 * const code far Screen4_CLabels[2];
extern   TImage                 * const code far Screen4_Images[1];
extern   TCImage                 * const code far Screen4_CImages[1];



/////////////////////////
// Events Code Declarations
void bridg1();
void bridg2();
void chest();
void chetire();
void devyat();
void dva();
void enter();
void lamp();
void nol();
void odin();
void oratno();
void out();
void pyat();
void reset();
void sem();
void setting();
void tri();
void usttime();
void vosem();
void zpt();
void print_time();
void Read_Time();
void viv();
void wr();
void rd();
void pwm2_star();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Image1_Caption[];
extern char Image2_Caption[];
extern char Image5_Caption[];
extern char BoxRound2_Caption[];
extern char Label1_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Button11_Caption[];
extern char Button12_Caption[];
extern const far char BoxRound1_Caption[];
extern char Label2_Caption[];
extern char Button14_Caption[];
extern char Button15_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Box3_Caption[];
extern char Box4_Caption[];
extern char BoxRound3_Caption[];
extern char Label3_Caption[];
extern const far char Image3_Caption[];
extern const far char Label4_Caption[];
extern const far char Label5_Caption[];
extern char Image4_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawCImage(TCImage *ACimage);
void DrawBox(TBox *ABox);
void DrawRoundBox(TBox_Round *Around_box);
void DrawCRoundBox(TCBox_Round *ACround_box);
void Check_TP();
void Start_TP();